﻿#define _CRT_SECURE_NO_DEPRECATE
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <iostream>
#include <iterator>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <sstream>
#include <fstream>
#include <ctime>
#include <cstring>
#include <functional>
#include <bitset>
#pragma comment(linker, "/STACK:66777216")
using namespace std;
#define pb push_back
#define ppb pop_back
#define pi 3.1415926535897932384626433832795028841971
#define mp make_pair
#define x first
#define y second
#define pii pair<int,int>
#define pdd pair<double,double>
#define INF 1000000000
#define FOR(i,a,b) for (int _n(b), i(a); i <= _n; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b);i>=_b;i--)
#define all(c) (c).begin(), (c).end()
#define SORT(c) sort(all(c))
#define rep(i,n) FOR(i,1,(n))
#define rept(i,n) FOR(i,0,(n)-1)
#define L(s) (int)((s).size())
#define C(a) memset((a),0,sizeof(a))
#define VI vector <int>
#define ll long long

int a, b, c, d, n, m, k;
pii mas[100002], hum[100002];
vector<pii> sm[100002];
VI faces[200002];

bool used[100002];
int timer, tin[100002], fup[100002];
bool bridge[200002];
void dfs(int v, int p = -1) {
	used[v] = true;
	tin[v] = fup[v] = timer++;
	rept(i, L(sm[v])) {
		int to = sm[v][i].x;
		if (to == p)  continue;
		if (used[to])
			fup[v] = min(fup[v], tin[to]);
		else {
			dfs(to, v);
			fup[v] = min(fup[v], fup[to]);
			if (fup[to] > tin[v]) {
				bridge[sm[v][i].y / 2] = 1;
			}
		}
	}
}

void find_bridges() {
	timer = 0;
	memset(bridge, 0, m);
	memset(used, 0, n);
	rept(i, n) {
		if (!used[i]) {
			dfs(i);
		}
	}
}

inline pii operator -(const pii &a, const pii &b) {
	return mp(a.x - b.x, a.y - b.y);
}
inline ll vec(const pii &a, const pii &b) {
	return (ll)a.x * b.y - (ll)b.x * a.y;
}
inline int cet(const pii &a) {
	if (a.x > 0 && a.y >= 0) return 0; else
	if (a.x <= 0 && a.y > 0) return 1; else
	if (a.x < 0 && a.y <= 0) return 2; else
	return 3;
}

class cmp_ang {
	int center;
public:
	cmp_ang(int center) : center(center)
	{ }
	bool operator() (const pii &a, const pii &b) const {
		pii v1 = mas[a.x] - mas[center];
		pii v2 = mas[b.x] - mas[center];
		int c1 = cet(v1), c2 = cet(v2);
		if (c1 != c2) return c1 < c2;
		return vec(v1, v2) > 0;
	}
};

int embed() {
	vector < vector<char> > used(n);
	rept(i, n) {
		used[i].resize(L(sm[i]));
	}
	int c = 0;
	rept(i, n) {
		sort(all(sm[i]), cmp_ang(i));
	}
	rept(i, n) {
		rept(j, L(sm[i])) {
			if (!used[i][j]) {
				used[i][j] = true;
				int v = sm[i][j].x, ne = sm[i][j].y, pv = i;
				ll s = vec(mas[pv], mas[v]);
				VI face;
				for (;;) {
					face.pb(v);
					vector<pii>::iterator it = lower_bound(sm[v].begin(), sm[v].end(), mp(pv, -1), cmp_ang(v));
					if (++it == sm[v].end())  it = sm[v].begin();
					if (used[v][it - sm[v].begin()])  break;
					used[v][it - sm[v].begin()] = true;
					pv = v, v = it->x, ne = it->y;
					s += vec(mas[pv], mas[v]);
				}
				if (s >= 0) continue;
				faces[c].swap(face);
				++c;
			}
		}
	}
	return c;
}

int nh[200002];
inline ll brute() {
	find_bridges();
	rept(i, n) {
		int j = 0;
		while (j < L(sm[i])) {
			if (bridge[sm[i][j].y / 2]) {
				swap(sm[i][j], sm[i].back());
				sm[i].ppb();
			} else {
				++j;
			}
		}
	}
	int nc = embed();
	++nc;

	memset(nh, 0, nc * sizeof(int));
	rept(ii, k) {
		pii p = hum[ii];
		long double by = 1e100;
		int nb = -1, num = -1;
		rept(nf, nc - 1) {
			int cnt = 0;
			long double ty = 1e101;
			const VI &face = faces[nf];
			rept(i, L(face)) {
				pii p1 = mas[face[i]];
				pii p2 = mas[face[i < L(face) - 1 ? i + 1 : 0]];
				if (p1.x > p2.x) swap(p1, p2);
				if (p.x < p1.x || p.x >= p2.x) continue;
				if (vec(p2 - p1, p - p1) >= 0) continue;
				++cnt;
				long double cy = (long double)(p2.y - p1.y) / (p2.x - p1.x) * (p.x - p1.x) + p1.y;
				if (cy < ty) {
					ty = cy;
				}
			}
			if (cnt % 2 && ty < by) {
				by = ty;
				num = nf;
			}
		}
		if (num != -1) ++nh[num]; else
		++nh[nc - 1];
	}

	ll ans = 0;
	rept(i, nc) {
		ans += (ll)nh[i] * (nh[i] - 1) / 2;
	}
	return ans;
	
}
int main() {
	freopen("archaeology.dat", "r", stdin);
	freopen("archaeology.sol", "w", stdout);
    
	scanf("%d%d%d", &n, &m, &k);
	rept(i, n) {
		scanf("%d%d", &mas[i].x, &mas[i].y);
	}
	rept(i, m) {
		scanf("%d%d", &a, &b); --a; --b;
		sm[a].pb(mp(b, 2 * i));
		sm[b].pb(mp(a, 2 * i + 1));
	}
	rept(i, k) {
		scanf("%d%d", &hum[i].x, &hum[i].y);
	}

	ll ans = brute();

	cout << ans << endl;
}
